# Class VulkanMemoryAllocateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanMemoryAllocateInfo.Builder

Enclosing class:
  `VulkanMemoryAllocateInfo`

public static final class VulkanMemoryAllocateInfo.Builder extends Object
Builds instances of type `VulkanMemoryAllocateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanMemoryAllocateInfo`
  `build()`
  Builds a new `VulkanMemoryAllocateInfo`.
  `final VulkanMemoryAllocateInfo.Builder`
  `from(VulkanMemoryAllocateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanMemoryAllocateInfoType` instance.
  `final VulkanMemoryAllocateInfo.Builder`
  `setMemoryTypeIndex(VulkanMemoryTypeIndex memoryTypeIndex)`
  Initializes the value for the `memoryTypeIndex` attribute.
  `final VulkanMemoryAllocateInfo.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanMemoryAllocateInfo.Builder from(VulkanMemoryAllocateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanMemoryAllocateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VulkanMemoryAllocateInfo.Builder setSize(long size)
    Initializes the value for the `size` attribute.
    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### setMemoryTypeIndex

    public final VulkanMemoryAllocateInfo.Builder setMemoryTypeIndex(VulkanMemoryTypeIndex memoryTypeIndex)
    Initializes the value for the `memoryTypeIndex` attribute.
    Parameters:
      `memoryTypeIndex` - The value for memoryTypeIndex
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanMemoryAllocateInfo build()
    Builds a new `VulkanMemoryAllocateInfo`.
    Returns:
      An immutable instance of VulkanMemoryAllocateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing